// Stage3D Shoot-em-up Tutorial Part 5
// by Christer Kaitila - www.mcfunkypants.com

// GameSaves.as
// A simple highscore and level save game system.
// For now, only high score is used (by the GUI), but you
// could implement an "unlocked" levels menu to allow players
// to skip levels they have completed when starting a new game.

package
{
	// For more information on "Flash Cookies" see:
	// http://gamedev.michaeljameswilliams.com/2009/03/18/avoider-game-tutorial-11/
	// http://en.wikipedia.org/wiki/Local_shared_object

	public class GameSaves
	{
		import flash.net.SharedObject;

		private var _saves:SharedObject;
		
		// class constructor
		public function GameSaves()
		{
			trace("Initializing game save system");
			try
			{
				_saves = SharedObject.getLocal("SaveGame");
			}
			catch ( sharedObjectError:Error )
			{
				trace( "Unable to init game save system: " 
					+ sharedObjectError.name + " " + sharedObjectError.message );
			}
		}
		
		public function get level():int
		{
			try
			{
				if (!_saves) return 0;
				if (_saves.data.level == null) return 0;
				trace("Loaded level is " + _saves.data.level);
				return _saves.data.level;
			}
			catch ( sharedObjectError:Error )
			{
				trace( "Unable to load score: " 
					+ sharedObjectError.name + " " + sharedObjectError.message );
			}
			return 0;
		}

		public function get score():int
		{
			try
			{
				if (!_saves) return 0;
				if (_saves.data.score == null) return 0;
				trace("Loaded score is " + _saves.data.score);
				return _saves.data.score;
			}
			catch ( sharedObjectError:Error )
			{
				trace( "Unable to load score: " 
					+ sharedObjectError.name + " " + sharedObjectError.message );
			}
			return 0;
		}

		public function set level(num:int):void
		{
			try
			{
				if (!_saves) return;
				_saves.data.level = num;
				_saves.flush();
				trace("Saved level set to: " + num);
			}
			catch ( sharedObjectError:Error )
			{
				trace( "Unable to save level: " 
					+ sharedObjectError.name + " " + sharedObjectError.message );
			}
		}

		public function set score(num:int):void
		{
			try
			{
				if (!_saves) return;
				_saves.data.score = num;
				_saves.flush();
				trace("Saved score set to: " + num);
			}
			catch ( sharedObjectError:Error )
			{
				trace( "Unable to save score: " 
					+ sharedObjectError.name + " " + sharedObjectError.message );
			}
		}

	} // end class
} // end package